﻿using OpenQA.Selenium;
using OpenQA.Selenium.Chrome;
using System;
/*using System.Configuration;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;*/
using System.Diagnostics;
/*using System.Drawing;
using System.Linq;
using System.Text;*/
using System.Windows.Forms;
//using System.Security;
using System.Net.NetworkInformation;
using System.Net;

namespace LANDESK_Web_Remote
{
    public partial class MainDisplay : Form
    {

        /*START - Code for global hotkey*/
        [System.Runtime.InteropServices.DllImport("user32.dll")]
        private static extern bool RegisterHotKey(IntPtr hWnd, int id, int fsModifiers, int vk);
        [System.Runtime.InteropServices.DllImport("user32.dll")]
        private static extern bool UnregisterHotKey(IntPtr hWnd, int id);

        enum KeyModifier
            {
                None = 0,
                Alt = 1,
                Control = 2,
                Shift = 4,
                WinKey = 8
            }
        /*END - Code for global hotkey*/

        IWebDriver driver;

        ManageRemoteCredentials ManageRemoteCredentials;

        int MyKeyCounter = 0;

        public MainDisplay()
        {
            InitializeComponent();

            

            Shared.SetMainDisplay(this);
            this.WindowState = FormWindowState.Minimized;

            /*START - Code for global hotkey*/
            int id = 0;     // The id of the hotkey. 
                RegisterHotKey(this.Handle, id, (int)KeyModifier.None, System.Windows.Forms.Keys.Escape.GetHashCode()); // Defines the Key modifier (value of "None" if not used) and the hotkey. ID is used if multiple hotkeys are initialized.
            /*END - Code for global hotkey*/
        }


        /*START - Code for global hotkey*/
        protected override void WndProc(ref Message m)
            {
                base.WndProc(ref m);

                if (m.Msg == 0x0312)
                {
                    /* Note that the three lines below are not needed if you only want to register one hotkey.
                     * The below lines are useful in case you want to register multiple keys, which you can use a switch with the id as argument, or if you want to know which key/modifier was pressed for some particular reason. */

                    //Keys key = (Keys)(((int)m.LParam >> 16) & 0xFFFF);                  // The key of the hotkey that was pressed.
                    //KeyModifier modifier = (KeyModifier)((int)m.LParam & 0xFFFF);       // The modifier of the hotkey that was pressed.
                    //int id = m.WParam.ToInt32();                                        // The id of the hotkey that was pressed.

                    MyKeyCounter++; // Every time escape is pressed, increment by one to keep track of # key presses.
                    if (!ResetCounter.Enabled) // Ensure that the counter is enabled. If it is, start the timer.
                        ResetCounter.Start();


                       // ResetCounter.Stop(); // Stop the timer.
                       // MyKeyCounter = 0; // Reset key counter.

                    /*    if (this.Visible == false)
                            Show();
                        else
                            Hide();*/
                }
            }
        /*END - Code for global hotkey*/
        private void MainDisplay_Load(object sender, EventArgs e)
        {
            //For 100% visibility, consider changing the registry to show all notification icons.
            //There is no way to program it to stay visible all the time. Only user's can set this.
            //moreComputerInformation.Show();
            //MoveSubForm(this, e);
            
           // currentUser.Text = Shared.getCurrentUser();
        }

        protected override void OnFormClosing(FormClosingEventArgs e)
        {
            if ((!(e.CloseReason == CloseReason.WindowsShutDown))&&(!(e.CloseReason == CloseReason.TaskManagerClosing)))
            {
                base.OnFormClosing(e);

                e.Cancel = true;

                Hide();
            }
            else
            {
                driver.Quit();
            }
            /*START - Code for global hotkey
                else
                {
                    UnregisterHotKey(this.Handle, 0);       // Unregister hotkey with id 0 before closing the form. You might want to call this more than once with different id values if you are planning to register more than one hotkey.
                }
            END - Code for global hotkey*/
        }

        private void NotifyIcon_MouseClick(object sender, MouseEventArgs e)
        {
            this.WindowState = FormWindowState.Normal;
            Show();
        }


        // The ResetCounter waits to see if the user has pressed the escape key 3 times within an alloted time set on the timer properties.
        // If it goes over the time, the timer stoped and the key counter is reset.
        private void ResetCounter_Tick(object sender, EventArgs e)
        {
            //MessageBox.Show("Counter is running...");
            if (MyKeyCounter == 2)
            {
                //MessageBox.Show("Hotkey has been pressed! Number of times: " + MyKeyCounter);
                if (!(this.WindowState == FormWindowState.Normal))
                {
                    this.WindowState = FormWindowState.Normal;
                    Show();
                }
                else
                {
                    Hide();
                    this.WindowState = FormWindowState.Minimized;
                }
            }
            MyKeyCounter = 0;
            ResetCounter.Stop();
        }

        private void Connect_Click(object sender, EventArgs e)
        {
            ConnectToPC();
        }

        private void ConnectToPC()
        {
            if (ValidateComputerID())
            {
                try
                {
                    if (ValidateConnectivity())
                    {
                        try
                        {
                            var driverService = ChromeDriverService.CreateDefaultService();
                            driverService.HideCommandPromptWindow = true;
                            ChromeOptions options = new ChromeOptions();
                            options.AddArguments("disable-infobars");

                            var drivers = new[] { 1, 2, 3 };

                            /*driver = new ChromeDriver(driverService, options)
                            {
                                Url = "https:\\" + computerID.Text + ":4343"
                            };*/

                            driver = new ChromeDriver(driverService, options);
                            System.Threading.Thread.Sleep(500);
                            driver.Url = "https:\\" + computerID.Text + ":4343";

                            try
                            {
                                IWebElement username = driver.FindElement(By.Id("username_input"));
                                //string configUsername = ConfigurationManager.AppSettings["Username"];
                                string configUsername = Properties.Settings.Default.Username;
                                if (configUsername == null || configUsername == "")
                                    username.SendKeys(Shared.GetCurrentUser());
                                else
                                    username.SendKeys(configUsername);
                            }
                            catch
                            { }
                            try
                            {
                                IWebElement password = driver.FindElement(By.Id("password_input"));
                                //string configPassword = ConfigurationManager.AppSettings["Password"]; // This should only be visible as ciphertext
                                string configPassword = Properties.Settings.Default.Password;
                                //MessageBox.Show("password: " + configPassword); // CONFIRMED CIPHERTEXT
                                if (configPassword != null || configPassword != "") // if config password is NOT null or empty, there should be a saved password in ciphertext.
                                    password.SendKeys(Shared.ToInsecureString(Shared.DecryptString(Properties.Settings.Default.Password)));
                                //password.SendKeys(Shared.ToInsecureString(Shared.DecryptString(ConfigurationManager.AppSettings["Password"])));
                            }
                            catch { }
                            try
                            {
                                IWebElement domain = driver.FindElement(By.Id("domain_input"));
                                //string configdomain = ConfigurationManager.AppSettings["domain"];
                                string configdomain = Properties.Settings.Default.Domain;
                                if (configdomain == null || configdomain == "")
                                    try
                                    {
                                        domain.SendKeys(System.DirectoryServices.ActiveDirectory.Domain.GetComputerDomain().ToString()); 
                                    }
                                    catch (Exception ex)  //just for demonstration...it's always best to handle specific exceptions
                                    {
                                        MessageBox.Show("An error occurred while trying to obtain the domain from your PC.");
                                    }
                                    
                                else
                                    domain.SendKeys(configdomain);
                            }
                            catch { }
                            UpdateComboBoxList();
                            //Process.Start("chrome.exe", "https:\\"+computerID.Text+":4343");
                            Hide();
                            this.WindowState = FormWindowState.Minimized;
                            try
                            {
                                Process[] proc = Process.GetProcessesByName("chromedriver");

                                int n = 0;
                                while (n < proc.Length)
                                {
                                    proc[n].Kill();
                                    n++;
                                }
                            }
                            catch { }
                        }
                        catch (Exception e)
                        {
                            MessageBox.Show("Error initializing Chrome: " + e, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        }
                    }
                }
                catch
                {
                    MessageBox.Show("The provided Computer ID or IP not reachable.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }

            }
        }

        private Boolean ValidateComputerID()
        {
            try
            {
                if (computerID.Text == null || computerID.Text == "")
                {
                    MessageBox.Show("Error: Invalid Computer ID - no Computer ID has been entered.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return false;
                }
                else if (computerID.Text.Length < 3)
                {
                    MessageBox.Show("Error: Invalid Computer ID - the Computer ID must contain a value of 3+ characters long.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return false;
                }
                else
                    return true;
            }
            catch
            {
                MessageBox.Show("Error: An unknown error has occured. Please try again.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }
        }

        Boolean ValidateConnectivity()
        {
            try
            {
                Ping x = new Ping();

                IPAddress address = Shared.GetIpFromHost(computerID.Text);

                PingReply reply = x.Send(address);

                if (reply.Status == IPStatus.Success)
                    return true;
                else
                {
                    MessageBox.Show(computerID.Text + " is not reachable.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return false;
                }
            }
            catch
            {
                MessageBox.Show(computerID.Text + " is not reachable.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }
        }

        protected void ComputerID_OnKeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 13)
            {
                ConnectToPC();
            }
        }

        private void UpdateComboBoxList()
        {
            string computerIDtemp = computerID.Text; // stores value into a local variable, as the directly accessed text value may be removed causing issues causing a blank insert.
            try
            {
                computerID.Items.Remove(computerIDtemp); // tries to remove computer ID if it exists in the combo box, will re-add it to top of list as it was most recently used.
            }
            catch { }
            computerID.Items.Insert(0, computerIDtemp);
            computerID.Text = computerIDtemp;
        }

        private void RemoteCredentials_Click(object sender, EventArgs e)
        {
            ManageRemoteCredentials = new ManageRemoteCredentials();
            ManageRemoteCredentials.Show();
        }

        private void CShare_Click(object sender, EventArgs e)
        {
            if (ValidateComputerID())
            {
                if (ValidateConnectivity())
                    Process.Start("explorer.exe", "\\\\" + computerID.Text + "\\c$");
            }
        }

        private void Ping_Click(object sender, EventArgs e)
        {
            if (ValidateComputerID())
            {
                Process.Start("cmd.exe", "/K ping " + computerID.Text + " -t"); // Note: You can use /C (instead of /K) switch if you want cmd.exe to close after it has run the command.

            }
        }

        private void Help_Click(object sender, EventArgs e)
        {
            MessageBox.Show("RWJBH - IS Help Desk Web Remote Utility\nVersion: 1.6\nCreated by: Jared Kohr\n\nHow to use:\n1. Enter a computer ID or IP address into the textbox.\n2. Select an option.\nNote: The current options available are landesk web remote control, access c share, local user and groups, computer management, event viewer, services, ping, and trace route.\n\nPlease also note that to show/dismiss this application, you can press [esc] twice. The window will always appear on top of other applications. Closing the window will only collapse it to your system tray. To completely close the application, do so in task manager.\n\nAdditional Information On The Connect Feature:\nThe box you enter the computer ID or IP keeps a history of your past connections for the duration this program is kept open with the most recent connections being at the top of the drop down menu. This box also features autocompletion capabilities. If you enter a computer ID you have connected to previously, it will move the computer to the top of the drop down list in your history and remove the old listing.\n\nAdditional Information On Remote Credential Manager:\nTo make remote connections easier to set up, you can enter your information into the Remote Credential Manager. It will enter your information into the web page automatically after you click connect. You can enter as much or as little information as you want. If you have not specified your username in the Remote Credential Manager, the application will pull the current user of the computer for the username. The default domain is \"RWJUH\". If no password is specified, then no password will be entered.\n\nRemoteRegistry.exe and who.vbs were obtained from \"LDMSPlugins\", a project created by Jared Barneck.", "About", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void eventvwr_Click(object sender, EventArgs e)
        {
            if (ValidateComputerID())
            {
                if (ValidateConnectivity())
                    Process.Start(Shared.GetWinPath() + @"\System32\eventvwr.exe", computerID.Text);
            }
        }

        private void tracert_Click(object sender, EventArgs e)
        {
            if (ValidateComputerID())
            {
                Process.Start("cmd.exe", "/C tracert " + computerID.Text + " & pause "); // Note: You can use /C (instead of /K) switch if you want cmd.exe to close after it has run the command.
            }
        }

        private void lusrmgr_Click(object sender, EventArgs e)
        {

            if (ValidateComputerID())
            {
                if (ValidateConnectivity())
                    Process.Start(Shared.GetWinPath() + @"\System32\lusrmgr.msc", "/computer=" + computerID.Text);
            }
        }

        private void compmgmt_Click(object sender, EventArgs e)
        {
            if (ValidateComputerID())
            {
                if (ValidateConnectivity())
                    Process.Start(Shared.GetWinPath() + @"\System32\compmgmt.msc", "/computer=" + computerID.Text);
            }
        }

        private void services_Click(object sender, EventArgs e)
        {
            if (ValidateComputerID())
            {
                if (ValidateConnectivity())
                    Process.Start(Shared.GetWinPath() + @"\System32\services.msc", "/computer=" + computerID.Text);
            }
        }

        private void regedit_Click(object sender, EventArgs e)
        {
            if (ValidateComputerID())
            {
                if (ValidateConnectivity())
                    Process.Start(@"RemoteRegedit.exe", computerID.Text);
            }
        }
    }
}
